/////////////////////////////////
// AquesTalkTerm -  Termnal と AquesTalk Pico LSIの中継スケッチ
//   ターミナルの送信改行コードはCRに設定すること
// by N.Yamazaki AQUEST Corp.  <http://www.a-quest.com>

// I2Cのクロックを変更するときは、Wire\utility\twi.h #define TWI_FREQ 100000L を書き換える
#include <Wire.h>

#define I2C_ADDR_AQUESTALK 0x2E

byte  bRespReq=1;	// 1: 応答待ち

void setup()
{
	Wire.begin();  // for Master
	Serial.begin(9600);
	pinMode(13, OUTPUT);    
}

void loop()
{
	// ターミナルから入力があればそのままI2Cスレーブに転送（1byte単位）
	if (Serial.available()>0) {
		byte c = Serial.read();
		Wire.beginTransmission(I2C_ADDR_AQUESTALK);
		Wire.write(c);
		Wire.endTransmission();    // stop transmitting
		if(c=='\r')  bRespReq=1;  // 改行でコマンド応答待ちのセット
	}

	if(bRespReq){
  		// I2Cスレーブの応答をターミナル側に返す
		Wire.requestFrom(I2C_ADDR_AQUESTALK, 1);
		if(Wire.available()>0){
		digitalWrite(13, HIGH);   // set the LED on
			byte c = Wire.read();
			if(c=='*' || c==0xFF){
				delay(10);		// スレーブが処理中なのでしばらく放っておく 10ms以上
			}
			else {
				Serial.write(c);
			}
			if(c=='>')	bRespReq=0;	// コマンド応答待ちの解除
			digitalWrite(13, LOW);   // set the LED on
		}
		else { // NOACK または応答がなかった時
			// スレーブが動いていない可能性が高い
			delay(100);
		}
	}
}
